import processing.core.*; 
import processing.xml.*; 

import java.io.File; 
import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class updownleftright extends PApplet {





// load Minim


AudioPlayer playerStart;
AudioPlayer playerDie;
AudioPlayer music;
Minim minim;

// to be able to print to the text files
PrintWriter output;

PImage start;
PImage end;

// strings for the ghost text files
String[] lines2;
String[] lines3;
String[] lines4;
String[] lines5;
String[] lines6;
String[] lines7;
String[] lines8;
String[] lines9;
String[] lines10;
String[] lines11;
String[] lines12;
String[] lines13;
String[] lines14;
String[] lines15;
String[] lines16;
String[] lines17;
String[] lines18;
String[] lines19;
String[] lines20;

// sequential counter for each step made
int index = 0;


// height of the game
int gameHeight = (screen.height/10)*8;

// position and size of player and enemy squares
int rectX = PApplet.parseInt(gameHeight*0.75f);
int rectY = PApplet.parseInt(gameHeight/2);
int rectWidth = PApplet.parseInt(gameHeight/40);
int rectHeight = PApplet.parseInt(gameHeight/40);
int redrectX = PApplet.parseInt(gameHeight*0.25f);
int redrectY = PApplet.parseInt(gameHeight/2); 
int gridsize = PApplet.parseInt(gameHeight/80);

// variable for when the game starts
int startgame = 1;

// is player alive or dead
int dead = 0;

// variable to activate the enemy whenever the player takes a step
int enemy = 0;

int enemySpeed = 0;

DrawGhosts ghosts;
Enemy redEnemy;
Player newPlayer;
Renamer rename;



PGraphics icon;
PImage appimg;

public void setup() {
  size(gameHeight, gameHeight);

  // load app icon
  icon = createGraphics(16, 16, JAVA2D);
  frame.setResizable(true);
  appimg = loadImage("data/16x16.png");
  icon.beginDraw();
  icon.image(appimg, 0, 0);
  icon.endDraw();
  frame.setIconImage(icon.image);
  
  // set app title
  frame.setTitle("Up, Down, Left, Right"); 

  // load minim and the game sounds/music
  minim = new Minim(this);
  playerStart = minim.loadFile("start.wav", 2048);
  playerDie = minim.loadFile("die.wav", 2048);
  music = minim.loadFile("soundtrack.mp3", 2048);

  // load start and end screens into memory
  start = loadImage("start.png");
  end = loadImage("end.png");

  // renames the files
  rename = new Renamer();
  rename.update();

  // Create a new file in the sketch directory
  output = createWriter("data/positions1.txt"); 

  // checks if files exist
  File f = new File(dataPath("positions1.txt"));
  if (!f.exists()) {
    println("File does not exist!");
    exit();
  } 
  else {
    println("All is OK!");
  }

  // text files for ghosts (could be made more gracefully, for loop?)
  lines2 = loadStrings("positions2.txt");
  lines3 = loadStrings("positions3.txt");
  lines4 = loadStrings("positions4.txt");
  lines5 = loadStrings("positions5.txt");
  lines6 = loadStrings("positions6.txt");
  lines7 = loadStrings("positions7.txt");
  lines8 = loadStrings("positions8.txt");
  lines9 = loadStrings("positions9.txt");
  lines10 = loadStrings("positions10.txt");
  lines11 = loadStrings("positions11.txt");
  lines12 = loadStrings("positions12.txt");
  lines13 = loadStrings("positions13.txt");
  lines14 = loadStrings("positions14.txt");
  lines15 = loadStrings("positions15.txt");
  lines16 = loadStrings("positions16.txt");
  lines17 = loadStrings("positions17.txt");
  lines18 = loadStrings("positions18.txt");
  lines19 = loadStrings("positions19.txt");
  lines20 = loadStrings("positions20.txt");


  // load ghosts, enemy and player
  ghosts = new DrawGhosts();
  redEnemy = new Enemy();
  newPlayer = new Player();

  // play music
  music.play();
} 


public void draw() {
  background(172);

  // updates the player
  newPlayer.update(); 

  // updates and draws the ghosts
  ghosts.update();  

  // draws the player square
  newPlayer.display(); 

  // updates and draws the enemy
  redEnemy.update();  

//  println(index);


  // displays start screen and waits for input
  if (startgame == 1) {
    image(start, 0, 0, width, height);
    startgame = 0;
    noLoop();
  }
}




// player controls
public void keyPressed() {
  if (key == 'a') {
    rectX = rectX - (gridsize+2); // moves the player rectangle sufficient distance
    output.print(rectX); // writes the positional data to file
    output.print(",");
    output.println(rectY);
    index = index + 1; // increments file to next line for both reading and writing
    enemy = 1; // tells the enemy that it's allowed to move
  } 
  else if (key == 'd') {
    rectX = rectX + (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  } 
  else if (key == 'w') {
    rectY = rectY - (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  } 
  else if (key == 's') {
    rectY = rectY + (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  }

  // force writing data to file even if game is not over
  /*
  
   if (key == 'p') {
   output.flush();  // Writes the remaining data to the file
   output.close();  // Finishes the file
   exit();  // Stops the program
   }*/
}


// start and reset game
public void keyReleased()
{
  // resets game upon loss
  if ((key=='r') && (dead == 1)) {
    dead = 0;
    loop(); 
    background(172);
    rectX = PApplet.parseInt(gameHeight*0.75f);
    rectY = PApplet.parseInt(gameHeight/2);
    rectWidth = PApplet.parseInt(gameHeight/40);
    rectHeight = PApplet.parseInt(gameHeight/40);
    redrectX = PApplet.parseInt(gameHeight*0.25f);
    redrectY = PApplet.parseInt(gameHeight/2); 
    index = 0;
    startgame = 1;
    music.pause();
    music.rewind();
    output.flush();  // Writes the remaining data to the file
    output.close();  // Finishes the file
    setup(); // jump back to void setup
  }

  // starts the game from start screen  
  if ((key==' ') && (dead == 0)) {
    startgame = 0;
    playerStart.play(); // play startup sound
    //dead = 0;
    loop();
  }
}

public void stop()
{
  // close Minim 
  playerStart.close();
  playerDie.close();
  music.close();
  minim.stop();

  super.stop();
}

class DrawGhosts{

  
public void update(){
  
  // stuff for possible for loop:
  // have an int alpha within the update that 
  // starts at 200 maybe and works its way sequentially 
  // down in the foor loop, for 1 - 20, or however many
  
  
// draw ghosts
// ghost 1
  if (index < lines2.length) {
    String[] pieces = split(lines2[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,200);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }
  
// ghost 2
  if (index < lines3.length) {
    String[] pieces = split(lines3[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,192);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  
  
// ghost 3
  if (index < lines4.length) {
    String[] pieces = split(lines4[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,184);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  
  
// ghost 4
  if (index < lines5.length) {
    String[] pieces = split(lines5[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,176);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 5
  if (index < lines6.length) {
    String[] pieces = split(lines6[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,168);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 6
  if (index < lines7.length) {
    String[] pieces = split(lines7[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,160);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 7
  if (index < lines8.length) {
    String[] pieces = split(lines8[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,152);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 8
  if (index < lines9.length) {
    String[] pieces = split(lines9[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,144);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 9
  if (index < lines10.length) {
    String[] pieces = split(lines10[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,136);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }    
  
// ghost 10
  if (index < lines11.length) {
    String[] pieces = split(lines11[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,128);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 11
  if (index < lines12.length) {
    String[] pieces = split(lines12[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,120);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 12
  if (index < lines13.length) {
    String[] pieces = split(lines13[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,112);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 13
  if (index < lines14.length) {
    String[] pieces = split(lines14[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,104);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 14
  if (index < lines15.length) {
    String[] pieces = split(lines15[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,96);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 15
  if (index < lines16.length) {
    String[] pieces = split(lines16[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,88);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 16
  if (index < lines17.length) {
    String[] pieces = split(lines17[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,80);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 17
  if (index < lines18.length) {
    String[] pieces = split(lines18[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,72);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  

// ghost 18
  if (index < lines19.length) {
    String[] pieces = split(lines19[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,64);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  
  
// ghost 19
  if (index < lines20.length) {
    String[] pieces = split(lines20[index], ',');
    if (pieces.length == 2) {
      float ghostX = PApplet.parseFloat(pieces[0]);
      float ghostY = PApplet.parseFloat(pieces[1]);
  rectMode(CENTER);
  fill(255,255,255,56);
  noStroke();
  rect(ghostX,ghostY,rectWidth,rectHeight);
}
  }  
  
}
}
class Enemy {

  

  public void update() {

    // start enemy block
    rectMode(CENTER);
    fill(200, 0, 0, 192);
    noStroke();


    // calculate angle between enemy and player
    // and give the enemy speed towards player
    // speed increases every 100 turns
    float a = atan2(redrectY-rectY, redrectX-rectX);
    int angle = PApplet.parseInt(degrees(a)+180);

    if (index > 100 && index < 200) {
      enemySpeed = 1;
    } 
    else if (index > 200 && index < 300) {
      enemySpeed = 2;
    } 
    else if (index > 300 && index < 400) {
      enemySpeed = 3;
    } 
    else if (index > 400 && index < 500) {
      enemySpeed = 4;
    } 
    else if (index > 500 && index < 600) {
      enemySpeed = 5;
    } 
    else if (index > 600 && index < 700) {
      enemySpeed = 6;
    } 
    else if (index > 700 && index < 800) {
      enemySpeed = 7;
    } 
    else if (index > 800 && index < 900) {
      enemySpeed = 8;
    } 
    else if (index > 900 && index < 1000) {
      enemySpeed = 9;
    }  
    else if (index > 1000 && index < 1100) {
      enemySpeed = 10;
    } 



    if (enemy == 1) {
      if ((angle >= 46) && (angle <= 135)) {
        redrectY = redrectY + (gridsize + enemySpeed);
      } 
      else if ((angle >= 136) && (angle <= 225)) {
        redrectX = redrectX - (gridsize + enemySpeed);
      } 
      else if ((angle >= 226) && (angle <= 315)) {
        redrectY = redrectY - (gridsize + enemySpeed);
      } 
      else if ((angle >= 316) && (angle <= 360)) {
        redrectX = redrectX + (gridsize + enemySpeed);
      } 
      else if ((angle >= 1) && (angle <= 45)) {
        redrectX = redrectX + (gridsize + enemySpeed);
      }
      enemy = 0;  // resets enemy to wait for player's next move
    }


    // draw actual enemy
    rect(redrectX, redrectY, rectWidth, rectHeight);

    // calculate if enemy is close enough to kill player
    if (dist(rectX, rectY, redrectX, redrectY) < rectWidth) {
      output.flush();  // Writes the remaining data to the file
      output.close();  // Finishes the file
      music.pause();
      music.rewind();

      // displays end screen
      playerDie.play();  // play dieing sound
      dead = 1;
      image(end, 0, 0, width, height);

      noLoop();
    }
  }
}

class Renamer{
  
  
  public void update(){
    
      // deleting oldest file
  String delFile = dataPath("positions20.txt");
  File d = new File(delFile);
  d.delete();

  // renaming all files incrementally (could be done with array?)

  String oldname19=dataPath("positions19.txt");
  File ff19=new File(oldname19);
  String newname19=dataPath("positions20.txt");
  ff19.renameTo(new File(newname19));
  String oldname18=dataPath("positions18.txt");
  File ff18=new File(oldname18);
  String newname18=dataPath("positions19.txt");
  ff18.renameTo(new File(newname18));
  String oldname17=dataPath("positions17.txt");
  File ff17=new File(oldname17);
  String newname17=dataPath("positions18.txt");
  ff17.renameTo(new File(newname17));
  String oldname16=dataPath("positions16.txt");
  File ff16=new File(oldname16);
  String newname16=dataPath("positions17.txt");
  ff16.renameTo(new File(newname16));
  String oldname15=dataPath("positions15.txt");
  File ff15=new File(oldname15);
  String newname15=dataPath("positions16.txt");
  ff15.renameTo(new File(newname15));
  String oldname14=dataPath("positions14.txt");
  File ff14=new File(oldname14);
  String newname14=dataPath("positions15.txt");
  ff14.renameTo(new File(newname14));
  String oldname13=dataPath("positions13.txt");
  File ff13=new File(oldname13);
  String newname13=dataPath("positions14.txt");
  ff13.renameTo(new File(newname13));
  String oldname12=dataPath("positions12.txt");
  File ff12=new File(oldname12);
  String newname12=dataPath("positions13.txt");
  ff12.renameTo(new File(newname12));
  String oldname11=dataPath("positions11.txt");
  File ff11=new File(oldname11);
  String newname11=dataPath("positions12.txt");
  ff11.renameTo(new File(newname11));
  String oldname10=dataPath("positions10.txt");
  File ff10=new File(oldname10);
  String newname10=dataPath("positions11.txt");
  ff10.renameTo(new File(newname10));
  String oldname9=dataPath("positions9.txt");
  File ff9=new File(oldname9);
  String newname9=dataPath("positions10.txt");
  ff9.renameTo(new File(newname9));
  String oldname8=dataPath("positions8.txt");
  File ff8=new File(oldname8);
  String newname8=dataPath("positions9.txt");
  ff8.renameTo(new File(newname8));
  String oldname7=dataPath("positions7.txt");
  File ff7=new File(oldname7);
  String newname7=dataPath("positions8.txt");
  ff7.renameTo(new File(newname7));
  String oldname6=dataPath("positions6.txt");
  File ff6=new File(oldname6);
  String newname6=dataPath("positions7.txt");
  ff6.renameTo(new File(newname6));
  String oldname5=dataPath("positions5.txt");
  File ff5=new File(oldname5);
  String newname5=dataPath("positions6.txt");
  ff5.renameTo(new File(newname5));
  String oldname4=dataPath("positions4.txt");
  File ff4=new File(oldname4);
  String newname4=dataPath("positions5.txt");
  ff4.renameTo(new File(newname4));
  String oldname3=dataPath("positions3.txt");
  File ff3=new File(oldname3);
  String newname3=dataPath("positions4.txt");
  ff3.renameTo(new File(newname3));
  String oldname2=dataPath("positions2.txt");
  File ff2=new File(oldname2);
  String newname2=dataPath("positions3.txt");
  ff2.renameTo(new File(newname2));
  String oldname1=dataPath("positions1.txt");
  File ff1=new File(oldname1);
  String newname1=dataPath("positions2.txt");
  ff1.renameTo(new File(newname1));
  // renaming done
  
  }
}
class Player {

  public void update() {

    // checking so player can't go out of bounds
    if (rectX <= 0) {
      rectX = gridsize;
    }
    if (rectX >= (width-10)) {
      rectX = (width - gridsize);
    } 
    if (rectY <= 0) {
      rectY = gridsize;
    } 
    if (rectY >= (height-10)) {
      rectY = (height - gridsize);
    }
  }



  public void display() {

    // draw player
    rectMode(CENTER);
    fill(0, 0, 0);
    noStroke();
    rect(rectX, rectY, rectWidth, rectHeight);
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#D4D0C8", "updownleftright" });
  }
}
