import java.io.File;



// load Minim
import ddf.minim.*;

AudioPlayer playerStart;
AudioPlayer playerDie;
AudioPlayer music;
Minim minim;

// to be able to print to the text files
PrintWriter output;

PImage start;
PImage end;

// strings for the ghost text files
String[] lines2;
String[] lines3;
String[] lines4;
String[] lines5;
String[] lines6;
String[] lines7;
String[] lines8;
String[] lines9;
String[] lines10;
String[] lines11;
String[] lines12;
String[] lines13;
String[] lines14;
String[] lines15;
String[] lines16;
String[] lines17;
String[] lines18;
String[] lines19;
String[] lines20;

// sequential counter for each step made
int index = 0;


// height of the game
int gameHeight = (screen.height/10)*8;

// position and size of player and enemy squares
int rectX = int(gameHeight*0.75);
int rectY = int(gameHeight/2);
int rectWidth = int(gameHeight/40);
int rectHeight = int(gameHeight/40);
int redrectX = int(gameHeight*0.25);
int redrectY = int(gameHeight/2); 
int gridsize = int(gameHeight/80);

// variable for when the game starts
int startgame = 1;

// is player alive or dead
int dead = 0;

// variable to activate the enemy whenever the player takes a step
int enemy = 0;

int enemySpeed = 0;

DrawGhosts ghosts;
Enemy redEnemy;
Player newPlayer;
Renamer rename;



PGraphics icon;
PImage appimg;

void setup() {
  size(gameHeight, gameHeight);

  // load app icon
  icon = createGraphics(16, 16, JAVA2D);
  frame.setResizable(true);
  appimg = loadImage("data/16x16.png");
  icon.beginDraw();
  icon.image(appimg, 0, 0);
  icon.endDraw();
  frame.setIconImage(icon.image);
  
  // set app title
  frame.setTitle("Up, Down, Left, Right"); 

  // load minim and the game sounds/music
  minim = new Minim(this);
  playerStart = minim.loadFile("start.wav", 2048);
  playerDie = minim.loadFile("die.wav", 2048);
  music = minim.loadFile("soundtrack.mp3", 2048);

  // load start and end screens into memory
  start = loadImage("start.png");
  end = loadImage("end.png");

  // renames the files
  rename = new Renamer();
  rename.update();

  // Create a new file in the sketch directory
  output = createWriter("data/positions1.txt"); 

  // checks if files exist
  File f = new File(dataPath("positions1.txt"));
  if (!f.exists()) {
    println("File does not exist!");
    exit();
  } 
  else {
    println("All is OK!");
  }

  // text files for ghosts (could be made more gracefully, for loop?)
  lines2 = loadStrings("positions2.txt");
  lines3 = loadStrings("positions3.txt");
  lines4 = loadStrings("positions4.txt");
  lines5 = loadStrings("positions5.txt");
  lines6 = loadStrings("positions6.txt");
  lines7 = loadStrings("positions7.txt");
  lines8 = loadStrings("positions8.txt");
  lines9 = loadStrings("positions9.txt");
  lines10 = loadStrings("positions10.txt");
  lines11 = loadStrings("positions11.txt");
  lines12 = loadStrings("positions12.txt");
  lines13 = loadStrings("positions13.txt");
  lines14 = loadStrings("positions14.txt");
  lines15 = loadStrings("positions15.txt");
  lines16 = loadStrings("positions16.txt");
  lines17 = loadStrings("positions17.txt");
  lines18 = loadStrings("positions18.txt");
  lines19 = loadStrings("positions19.txt");
  lines20 = loadStrings("positions20.txt");


  // load ghosts, enemy and player
  ghosts = new DrawGhosts();
  redEnemy = new Enemy();
  newPlayer = new Player();

  // play music
  music.play();
} 


void draw() {
  background(172);

  // updates the player
  newPlayer.update(); 

  // updates and draws the ghosts
  ghosts.update();  

  // draws the player square
  newPlayer.display(); 

  // updates and draws the enemy
  redEnemy.update();  

//  println(index);


  // displays start screen and waits for input
  if (startgame == 1) {
    image(start, 0, 0, width, height);
    startgame = 0;
    noLoop();
  }
}




// player controls
void keyPressed() {
  if (key == 'a') {
    rectX = rectX - (gridsize+2); // moves the player rectangle sufficient distance
    output.print(rectX); // writes the positional data to file
    output.print(",");
    output.println(rectY);
    index = index + 1; // increments file to next line for both reading and writing
    enemy = 1; // tells the enemy that it's allowed to move
  } 
  else if (key == 'd') {
    rectX = rectX + (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  } 
  else if (key == 'w') {
    rectY = rectY - (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  } 
  else if (key == 's') {
    rectY = rectY + (gridsize+2);
    output.print(rectX);
    output.print(",");
    output.println(rectY);
    index = index + 1;
    enemy = 1;
  }

  // force writing data to file even if game is not over
  /*
  
   if (key == 'p') {
   output.flush();  // Writes the remaining data to the file
   output.close();  // Finishes the file
   exit();  // Stops the program
   }*/
}


// start and reset game
void keyReleased()
{
  // resets game upon loss
  if ((key=='r') && (dead == 1)) {
    dead = 0;
    loop(); 
    background(172);
    rectX = int(gameHeight*0.75);
    rectY = int(gameHeight/2);
    rectWidth = int(gameHeight/40);
    rectHeight = int(gameHeight/40);
    redrectX = int(gameHeight*0.25);
    redrectY = int(gameHeight/2); 
    index = 0;
    startgame = 1;
    music.pause();
    music.rewind();
    output.flush();  // Writes the remaining data to the file
    output.close();  // Finishes the file
    setup(); // jump back to void setup
  }

  // starts the game from start screen  
  if ((key==' ') && (dead == 0)) {
    startgame = 0;
    playerStart.play(); // play startup sound
    //dead = 0;
    loop();
  }
}

void stop()
{
  // close Minim 
  playerStart.close();
  playerDie.close();
  music.close();
  minim.stop();

  super.stop();
}

